//low pass filter (LP12)
//taken mostly from lmms base code (it's GPL so it's good!)


float rca, rcb, rcc, rcq; //coeffcients
float bp0[2] = {0, 0}, lp0[2]={0, 0}, hp0[2]={0, 0}, last0[2]={0, 0};

float bound ( float min, float x, float max )
{
	if( x < min )
		return min;
	else if ( x > max )
		return max;
	else
		return x;
}

void calculateFilterCoeffs( float freq, float q )
{
	float sr = 1.0f / SAMPLE_RATE * 0.25f;
	float f = 1.0f / (freq * 2 * PI);

	rca = 1.0f - sr / ( f + sr );
	rcb = 1.0f - rca;
	rcc = f / ( f + sr );
	rcq = q * 0.25f;

//	printf("a %f b %f c %f q %f", rca, rcb, rcc, rcq);
}

float updateFilter ( float in0, int a ) // a == 0 | left side
{
	float lp, bp, hp, in;
	int n;
	for( n=4; n !=0; --n )
	{
		in = in0 + bp0[a] * rcq;
		in = bound( -1.0f, in, 1.0f );

		lp = in * rcb + lp0[a] * rca;
		lp = bound ( -1.0f, lp, 1.0f );

		hp = rcc * ( hp0[a] + in - last0[a]);
		hp = bound ( -1.0, hp, 1.0f );

		bp = hp * rcb + bp0[a] * rca;
		bp = bound( -1.0f, bp, 1.0f );

		last0[a] = in;
		lp0[a] = lp;
		hp0[a] = hp;
		bp0[a] = bp;
	}
//	printf("before: %f after %f\t", in0, lp);
	return lp;
}
